Bug 870860 (opencsg)

Summary: Review Request: opencsg - Library for Constructive Solid Geometry using OpenGL
Product: [Fedora] Fedora Reporter: Miro Hrončok <mhroncok>
Component: Package ReviewAssignee: Mario Blättermann <mario.blaettermann>
Status: CLOSED CURRENTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: unspecified    
Version: rawhideCC: jurman.greg+fas, loganjerry, mario.blaettermann, notting, package-review, spacewar, volker27
Target Milestone: ---Flags: mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 825489 Environment:
Last Closed: 2012-11-27 00:33:01 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 864187    

Description Miro Hrončok 2012-10-28 22:31:00 EDT
Spec URL: https://raw.github.com/gregjurman/opencsg-spec/master/opencsg.spec
SRPM URL: https://github.com/gregjurman/opencsg-spec/raw/master/opencsg-1.3.2-5.fc17.src.rpm

Description:
CSG is short for Constructive Solid Geometry and denotes an approach to model
complex 3D-shapes using simpler ones. I.e., two shapes can be combined by
taking the union of them, by intersecting them, or by subtracting one shape
of the other. The most basic shapes, which are not result of such a CSG
operation, are called primitives. Primitives must be solid, i.e., they must
have a clearly defined interior and exterior. By construction, a CSG shape is
also solid then.

Image-based CSG rendering (also z-buffer CSG rendering) is a term that denotes
algorithms for rendering CSG shapes without an explicit calculation of the
geometric boundary of a CSG shape. Such algorithms use frame-buffer settings
of the graphics hardware, e.g., the depth and stencil buffer, to compose CSG
shapes. OpenCSG implements a variety of those algorithms, namely the
Goldfeather algorithm and the SCS algorithm, both of them in several variants.

Fedora Account System Username: churchyard

Retaken bug #678955
Comment 1 Miro Hrončok 2012-10-28 22:34:11 EDT
I am sorry, I've sended it before editation, here are correct links:

Spec URL: https://raw.github.com/hroncok/opencsg-spec/master/opencsg.spec
SRPM URL: https://github.com/hroncok/opencsg-spec/raw/master/opencsg-1.3.2-5.fc17.src.rpm
Comment 2 Mario Blättermann 2012-10-29 08:23:15 EDT
Lifting FE-NEEDSPONSOR, I will sponsor Miro.
Comment 3 Mario Blättermann 2012-10-29 08:30:08 EDT
*** Bug 825489 has been marked as a duplicate of this bug. ***
Comment 4 Miro Hrončok 2012-10-31 14:13:57 EDT
Spec URL: https://raw.github.com/hroncok/SPECS/master/opencsg.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/opencsg-1.3.2-5.fc17.src.rpm

- Nothing has changed, I've just moved SRPM and SPEC to a new location
Comment 5 Mario Blättermann 2012-11-01 16:34:53 EDT
PLease don't bother with false positive rpmlint warnings and drop the docs from the -devel package. All the files are present anyway due to the main package.

Patch1 is actually not needed, you have just to inform the upstream folks about the wrong FSF address. However, if you want to patch the source files, don't patch license.txt. It's somewhat critical to touch license texts, I would discourage you to do so, and it is not allowed by the guidelines anyway:
https://fedoraproject.org/wiki/Common_Rpmlint_issues#incorrect-fsf-address


mv lib/* %{buildroot}/%{_libdir}/
doesn't keep the timestamps, why not use "cp -p" or even "install -D" instead?
Comment 6 Miro Hrončok 2012-11-13 20:00:22 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/opencsg.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/opencsg-1.3.2-6.fc17.src.rpm

- Removed FSF Address path
   - using sed instead, so the path is not needed to update in newer version
   - don't modify license file
- License exception explained in a comment
- Dropped doc form devel package
- Usiyng cp -pP instead of mv to preserve timestamps

Contacted the upstream about the FSF address issue.

What about 'dos2unix license.txt' - is it OK?
Comment 7 Mario Blättermann 2012-11-17 17:36:56 EST
(In reply to comment #6)
> What about 'dos2unix license.txt' - is it OK?
This is OK. This way the text won't be changed, it affects the line endings only, but doesn't touch the contents.


Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4699261

$ rpmlint -i -v *
opencsg.src: I: checking
opencsg.src: I: checking-url http://www.opencsg.org/ (timeout 10 seconds)
opencsg.src: I: checking-url http://www.opencsg.org/OpenCSG-1.3.2.tar.gz (timeout 10 seconds)
opencsg.i686: I: checking
opencsg.i686: I: checking-url http://www.opencsg.org/ (timeout 10 seconds)
opencsg.i686: E: incorrect-fsf-address /usr/share/doc/opencsg-1.3.2/license.txt
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

opencsg.x86_64: I: checking
opencsg.x86_64: I: checking-url http://www.opencsg.org/ (timeout 10 seconds)
opencsg.x86_64: E: incorrect-fsf-address /usr/share/doc/opencsg-1.3.2/license.txt
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

opencsg-debuginfo.i686: I: checking
opencsg-debuginfo.i686: I: checking-url http://www.opencsg.org/ (timeout 10 seconds)
opencsg-debuginfo.x86_64: I: checking
opencsg-debuginfo.x86_64: I: checking-url http://www.opencsg.org/ (timeout 10 seconds)
opencsg-devel.i686: I: checking
opencsg-devel.i686: I: checking-url http://www.opencsg.org/ (timeout 10 seconds)
opencsg-devel.i686: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

opencsg-devel.x86_64: I: checking
opencsg-devel.x86_64: I: checking-url http://www.opencsg.org/ (timeout 10 seconds)
opencsg-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

opencsg.spec: I: checking-url http://www.opencsg.org/OpenCSG-1.3.2.tar.gz (timeout 10 seconds)
7 packages and 1 specfiles checked; 2 errors, 2 warnings.

No recognizable issues.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    GPLv2 with exceptions
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    c790c92998f7113cb35cde825f81c5532755908a0a3f43c3c3c8df2326b3b925  OpenCSG-1.3.2.tar.gz
    c790c92998f7113cb35cde825f81c5532755908a0a3f43c3c3c8df2326b3b925  OpenCSG-1.3.2.tar.gz.packaged

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[+] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: Development files must be in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

----------------

PACKAGE APPROVED

----------------


Now you can go ahead with a SCM request once you are approved as a packager:
https://fedoraproject.org/wiki/Package_SCM_admin_requests#New_Packages

Please add my FAS username "mariobl" to the "Owners" field, because I'm not a provenpackager.
Comment 8 Miro Hrončok 2012-11-18 08:50:34 EST
New Package SCM Request
=======================
Package Name: opencsg
Short Description: Library for Constructive Solid Geometry using OpenGL
Owners: churchyard mariobl
Branches: f17 f18
InitialCC: gregjurman
Comment 9 Gwyn Ciesla 2012-11-18 12:11:38 EST
Git done (by process-git-requests).
Comment 10 Fedora Update System 2012-11-18 14:35:20 EST
opencsg-1.3.2-6.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/opencsg-1.3.2-6.fc18
Comment 11 Fedora Update System 2012-11-18 14:36:48 EST
opencsg-1.3.2-6.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/opencsg-1.3.2-6.fc17
Comment 12 Miro Hrončok 2012-11-18 17:36:57 EST
Thanks for sponsoring me and for the review.

As this is my first package, I tryed to do everything as described in the documentation, but I'm lost here.

https://fedoraproject.org/wiki/Join_the_package_collection_maintainers?rd=PackageMaintainers/Join#Submit_Package_as_Update_in_Bodhi

This page says:

> Do not submit "master" (aka rawhide) packages via bodhi.

So I did not. I can see f17 and f18 packages here:

https://admin.fedoraproject.org/updates/opencsg-1.3.2-6.fc17
https://admin.fedoraproject.org/updates/opencsg-1.3.2-6.fc18

But what about rawhide package? Is it already in the repository? Or how does it work?

Thanks
Comment 13 Mario Blättermann 2012-11-18 17:44:58 EST
(In reply to comment #12)
> Thanks for sponsoring me and for the review.
> 
> As this is my first package, I tryed to do everything as described in the
> documentation, but I'm lost here.
> 
> https://fedoraproject.org/wiki/
> Join_the_package_collection_maintainers?rd=PackageMaintainers/
> Join#Submit_Package_as_Update_in_Bodhi
> 
> This page says:
> 
> > Do not submit "master" (aka rawhide) packages via bodhi.
> 
> So I did not. I can see f17 and f18 packages here:
> 
> https://admin.fedoraproject.org/updates/opencsg-1.3.2-6.fc17
> https://admin.fedoraproject.org/updates/opencsg-1.3.2-6.fc18
> 
> But what about rawhide package? Is it already in the repository? Or how does
> it work?

Indeed, you have to build it only. Such builds for Rawhide are automatically picked up, you don't have to submit them explicitely.

But make sure to build them anyway. This way we get it quickly into the BuildRoot on Koji. For other branches, you have to request BuildRoot Overrides if there are other packages waiting for a review which depend on it.

In any case, welcome in the package maintainers group!
Comment 14 Fedora Update System 2012-11-18 21:28:33 EST
opencsg-1.3.2-6.fc17 has been pushed to the Fedora 17 testing repository.
Comment 15 Miro Hrončok 2012-11-23 18:32:57 EST
Mario, could you help me with this?

> This update has reached 3 days in testing and can be pushed to stable now if the maintainer wishes

How do i trigger such a puch? A link to a correct document about this would be great, no need to explain it here.

Thanks
Comment 16 Eric Smith 2012-11-23 20:13:39 EST
Isn't this documented in the "Join the package collection maintainers" page on the wiki?

In short, log into the Fedora Update System:

https://admin.fedoraproject.org/updates/

Use the "Login" link near the top left, then the "My Updates (n)" link below that.
Comment 17 Miro Hrončok 2012-11-24 08:17:50 EST
Thanks,
I see no information about pushng a package from testing to stable on that page (but it is a long page, so i might be wrong).


I see this note here:

https://fedoraproject.org/wiki/Package_update_HOWTO?rd=PackageMaintainers/UpdatingPackageHowTo#Submit_your_update_to_Bodhi

"If your update does not receive enough feedback to automatically push it to stable, you will have to submit it as a final update yourself. This can easily be done with the command-line tool, or with the web interface."

There is a link in the top right corner (on an update page when logged in) saying "Mark as Stable" -> but it took me a while to find that one.
Comment 18 Mario Blättermann 2012-11-24 13:43:15 EST
(In reply to comment #17)
> There is a link in the top right corner (on an update page when logged in)
> saying "Mark as Stable" -> but it took me a while to find that one.

I do it always the same way. Well, you could use the command line interface of Bodhi, but in my mind, the web interface is somewhat easier, and you get a clear overview over your packages.
Comment 19 Fedora Update System 2012-11-27 00:33:05 EST
opencsg-1.3.2-6.fc18 has been pushed to the Fedora 18 stable repository.
Comment 20 Fedora Update System 2012-11-28 06:28:09 EST
opencsg-1.3.2-6.fc17 has been pushed to the Fedora 17 stable repository.